[TITLE]
PIC16F84

[AUTORUN]
setup

[MENU]
erace,1,,
write,1,r,
read,0,w,ǂݏo
eeprom_write,1,r,EEPROM
eeprom_read,0,w,EEPROMǂݏo
config,0,,q[Yf[^ǂݏ

[MESSAGE]

[CODE]
#define	VPP			#VPP4
#define	VPP.dir		#VPP4.dir
#define	MCLR		#4
#define	MCLR.dir	#4.dir
#define	VCC			#VCC36
#define	VCC.dir		#VCC36.dir
#define	GND			#GND5
#define	GND.dir		#GND5.dir
#define	SCLK		#34
#define	SCLK.dir	#34.dir
#define	SDAT		#35
#define	SDAT.dir	#35.dir
#define	MAX_MEM		1024	// Word
#define	MAX_EEPROM	64		// Byte

WORD	wData, wWdata, wI, wJ, wK, wA;
WORD	wFlg, wAH, wAL, wAD, wLen;
BYTE	bCmd, bD, bBuff[256], key;

setup()
{
	InitIo();
	InitVolt();
	VppVolt( 13.5 );	VccVolt( 5.0 );
	VPP.dir = 1;	VPP = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC.dir = 1;	VCC = 0;
	GND.dir = 1;	GND = 1;
	SCLK.dir = 1;	SCLK = 0;
	SDAT.dir = 1;	SDAT = 0;
	Message("Pԃsɍ킹ăfoCXZbgĉ");
}

PowerOn()
{
	SCLK = 0;
	SDAT = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC = 1;
	Wait( 10, BASE_MS );
	MCLR.dir = 0;
	VPP = 1;
	Wait( 1, BASE_MS );
}

PowerOff()
{
	SCLK = 0;
	SDAT = 0;
	VPP = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC = 0;
}

skip_config()
{
	bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
	wData = 0x3fff;	WriteWordData();

	Clear( wK );
	do {
		Inc( wK );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
	} while( wK != 7 );
}

erace()
{
	PowerOn();

	skip_config();

	bCmd = 0x01;	TXcmd();	// Execute0001
	bCmd = 0x07;	TXcmd();	// Execute0111
	bCmd = 0x08;	TXcmd();	// 001000 Begin Programming
	Wait( 10, BASE_MS );
	bCmd = 0x01;	TXcmd();	// Execute0001
	bCmd = 0x07;	TXcmd();	// Execute0111
	Wait( 10, BASE_MS );

	PowerOff();
}

WriteWordData()
{
	Clear( wJ );
	Clear( SDAT );
	Pulse( SCLK );
	do {
		SDAT = wData>>wJ;
		Pulse( SCLK );
		Inc( wJ );
	} while( wJ != 14 );
	Clear( SDAT );
	Pulse( SCLK );
}

ReadWordData()
{
	bCmd = 0x04;	TXcmd();	// 000100 Read Data from Program Memory
	SDAT.dir = 0;	// SDAT input mode
	Wait( 1, BASE_MS );

	Clear( wJ );
	Clear( wData );
	Pulse( SCLK );
	do {
		Pulse( SCLK );
		wData = wData + (SDAT<<wJ);
		Inc( wJ );
	} while( wJ != 14 );
	Pulse( SCLK );
	SDAT.dir = 1;	// SDAT output mode
	Clear( SDAT );
}

write()
{
	PowerOn();

	Clear( wFlg );
	Clear( wA );	// PIC̃AhX
	while( 1 ) {
		wLen = 256;
		if( DataReq( wFlg, wAH, wAL, bBuff, wLen ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	write_end;
		}
		wFlg = 1;		// pf[^ɐݒ肵Ă
		if( wLen == 0 ) {
			break;		// I
		}
		// wAH ͖gp
		wAL = wAL / 2;		// [h̃AhXɒ
		if( wAL >= 0x2000 && wA < 0x2000 ) {
			bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
			wData = 0x3fff;	WriteWordData();
			wA = 0x2000;
		}
		while( wA < wAL ) {	// ݊JnAhX܂ŃXLbv
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
		Clear( wI );
		while( wI != wLen ) {
			// P[h̏݃f[^obt@o
			// ʁAʔ]
			wWdata = bBuff[wI];
			Inc( wI );
			wWdata = wWdata + (bBuff[wI]<<8);
			Inc( wI );
			// ݂̃f[^ǂݏoď݃f[^ƈ珑
			ReadWordData();
			if( wData != wWdata ) {
				// 
				bCmd = 0x02;	TXcmd();	// 000010 Load Data for Program Memory
				wData = wWdata;
				WriteWordData();
				bCmd = 0x08;	TXcmd();	// 001000 Begin Programming
				Wait( 10, BASE_MS );
				// xt@C
				ReadWordData();
				if( wData != wWdata ) {
					StartMsg();
					SendMsg("xt@CG[ AhX(Word) = ");
					bD = wA>>8;
					SendHex(bD);
					bD = wA&0xff;
					SendHex(bD);
					SendMsg("(HEX)");
					EndMsg();	// ̏I
					break;
				}
			}
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
	}
write_end:
	PowerOff();
}

read()
{
	PowerOn();

	Clear( wA );
	wI = MAX_MEM * 2;		// _vTCYoCgPʂɂĒʒm
	StartDump( 0, 0, wI );	// _vf[^
	while( wA < MAX_MEM ) {
		ReadWordData();
		bD = wData & 0xff;	// 
		DataDump( bD );
		bD = wData>>8;		// 
		DataDump( bD );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
		Inc( wA );
	}
	EndDump();

	PowerOff();
}

TXcmd()
{
	Clear( wJ );
	do {
		SDAT = bCmd>>wJ;
		Pulse( SCLK );
		Inc( wJ );
	} while( wJ != 6 );
	Clear( SDAT );
	Wait( 1, BASE_MS );
}

write_config()
{
	skip_config();

	ReadWordData();
	if( wData != wWdata ) {
		bCmd = 0x02;	TXcmd();	// 000010 Load Data for Program Memory
		wData = wWdata;
		WriteWordData();
		bCmd = 0x08;	TXcmd();	// 001000 Begin Programming
		Wait( 10, BASE_MS );
	}
}

SelPower()
{
	do {
		Message( "Power up timer  0:enabled  1:disabled  9:~  ?" );
		key = RecByte();
	} while( key != '0' && key != '1' && key != '9' );
}

SelWDT()
{
	do {
		Message( "WDT  0:disabled  1:enabled  9:~  ?" );
		key = RecByte();
	} while( key != '0' && key != '1' && key != '9' );
}

SelOsc()
{
	do {
		Message( "Oscillator  0:LP  1:XT  2:HS  3:RC  9:~  ?" );
		key = RecByte();
	} while( key != '0' && key != '1' && key != '2' && key != '3' && key != '9' );
}

SelYesNo()
{
	do {
		Message( "Write config  0:Yes  9:No  ?" );
		key = RecByte();
	} while( key != '0' && key != '9' );
}

config()
{
	PowerOn();

	skip_config();

	ReadWordData();
	Message( "݂̐ݒe" );
	if( wData & 0x8 ) {
		Message( "  Power up timer disabled" );
	} else {
		Message( "  Power up timer enabled" );
	}
	if( wData & 0x4 ) {
		Message( "  WDT enabled" );
	} else {
		Message( "  WDT disabled" );
	}
	if( (wData & 0x3) == 0 ) {
		Message( "  LP oscillator" );
	}
	if( (wData & 0x3) == 1 ) {
		Message( "  XT oscillator" );
	}
	if( (wData & 0x3) == 2 ) {
		Message( "  HS oscillator" );
	}
	if( (wData & 0x3) == 3 ) {
		Message( "  RC oscillator" );
	}
	SendCode( KEY_ON );		// L[{[h͗L
	SendCode( BUTTON_OFF );	// {^
	wWdata = 0x3ffc;
	while( 1 ) {
		SelPower();
		if( key == '9' ) {
			break;
		}
		if( key == '0' ) {
			wWdata = wWdata & 0x3ff7;
		}
		SelWDT();
		if( key == '9' ) {
			break;
		}
		if( key == '0' ) {
			wWdata = wWdata & 0x3ffb;
		}
		SelOsc();
		if( key == '9' ) {
			break;
		}
		wWdata = wWdata + key - '0';
		SelYesNo();
		if( key == '0' ) {
			Message( "݂܂" );
			write_config();
		} else {
			Message( "݂𒆎~܂" );
		}
		break;
	}
	SendCode( KEY_OFF );	// L[{[h͖
	SendCode( BUTTON_ON );	// {^L

	PowerOff();
}

ReadWordDataDM()
{
	bCmd = 0x05;	TXcmd();	// 000101 Read Data from Data Memory
	SDAT.dir = 0;	// SDAT input mode
	Wait( 1, BASE_MS );

	Clear( wJ );
	Clear( wData );
	Pulse( SCLK );
	do {
		Pulse( SCLK );
		wData = wData + (SDAT<<wJ);
		Inc( wJ );
	} while( wJ != 14 );
	Pulse( SCLK );
	SDAT.dir = 1;	// SDAT output mode
	Clear( SDAT );
}

eeprom_write()
{
	PowerOn();

	Clear( wFlg );
	Clear( wA );	// PIC̃AhX
	while( 1 ) {
		wLen = 64;
		if( DataReq( wFlg, wAH, wAL, bBuff, wLen ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	eeprom_write_end;
		}
		wFlg = 1;		// pf[^ɐݒ肵Ă
		if( wLen == 0 ) {
			break;		// I
		}
		while( wA < wAL ) {	// ݊JnAhX܂ŃXLbv
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
		Clear( wI );
		while( wI != wLen ) {
			// PoCg̏݃f[^obt@o
			wWdata = bBuff[wI];
			Inc( wI );
			// ݂̃f[^ǂݏoď݃f[^ƈ珑
			ReadWordDataDM();
			wData = wData & 0xff;
			if( wData != wWdata ) {
				// 
				bCmd = 0x03;	TXcmd();	// 000011 Load Data for Data Memory
				wData = wWdata;
				WriteWordData();
				bCmd = 0x08;	TXcmd();	// 001000 Begin Programming
				Wait( 10, BASE_MS );
				// xt@C
				ReadWordDataDM();
				wData = wData & 0xff;
				if( wData != wWdata ) {
					StartMsg();
					SendMsg("xt@CG[ AhX(Byte) = ");
					SendHex(wA);
					SendMsg("(HEX)");
					EndMsg();	// ̏I
					break;
				}
			}
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
	}
eeprom_write_end:
	PowerOff();
}

eeprom_read()
{
	PowerOn();

	Clear( wA );
	StartDump( 0, 0, MAX_EEPROM );	// _vf[^
	while( wA < MAX_EEPROM ) {
		ReadWordDataDM();
		bD = wData;
		DataDump( bD );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
		Inc( wA );
	}
	EndDump();

	PowerOff();
}
