[TITLE]
PIC16F88

[AUTORUN]
setup

[MENU]
erace,1,,
write,1,r,
read,0,w,ǂݏo
verify,0,,xt@C
eeprom_write,1,r,EEPROM
eeprom_read,0,w,EEPROMǂݏo

[MESSAGE]

[CODE]
#define	VPP			#VPP4
#define	VPP.dir		#VPP4.dir
#define	MCLR		#4
#define	MCLR.dir	#4.dir
#define	VCC			#VCC36
#define	VCC.dir		#VCC36.dir
#define	GND			#GND5
#define	GND.dir		#GND5.dir
#define	PGM			#9
#define	PGM.dir		#9.dir
#define	SCLK		#34
#define	SCLK.dir	#34.dir
#define	SDAT		#35
#define	SDAT.dir	#35.dir
#define	MAX_MEM		4096	// Word
#define	MAX_EEPROM	256		// Byte

BYTE	bCmd, bD, bBuff[256], key;
WORD	wData, wWdata, wI, wJ, wK, wA;
WORD	wFlg, wAH, wAL, wAD, wLen;

setup()
{
	InitIo();
	InitVolt();
	VppVolt( 13.5 );	VccVolt( 5.0 );
	PGM.dir = 1;	PGM = 0;
	VPP.dir = 1;	VPP = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC.dir = 1;	VCC = 0;
	GND.dir = 1;	GND = 1;
	SCLK.dir = 1;	SCLK = 0;
	SDAT.dir = 1;	SDAT = 0;
	Message("configf[^̓vOƋɏŉ");
	Message("Pԃsɍ킹ăfoCXZbgĉ");
}

PowerOn()
{
	SCLK = 0;
	SDAT = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC = 1;
	Wait( 100, BASE_US );
	MCLR.dir = 0;
	VPP = 1;
	Wait( 1, BASE_MS );
}

PowerOff()
{
	SCLK = 0;
	SDAT = 0;
	VPP = 0;
	MCLR.dir = 1;	MCLR = 0;
	VCC = 0;
}

skip_config()
{
	bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
	wData = 0x3fff;	WriteWordData();

	Clear( wK );
	do {
		Inc( wK );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
	} while( wK != 7 );
}

erace()
{
	PowerOn();

	bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
	wData = 0x3fff;	WriteWordData();

	bCmd = 0x1f;	TXcmd();	// chip erase
	Wait( 20, BASE_MS );

	PowerOff();
}

WriteWordData()
{
	Clear( wJ );
	Clear( SDAT );
	Pulse( SCLK );
	do {
		SDAT = wData>>wJ;
		Pulse( SCLK );
		Inc( wJ );
	} while( wJ != 14 );
	Clear( SDAT );
	Pulse( SCLK );
}

ReadWordData()
{
	bCmd = 0x04;	TXcmd();	// 000100 Read Data from Program Memory
	SDAT.dir = 0;	// SDAT input mode
	Wait( 1, BASE_MS );

	Clear( wJ );
	Clear( wData );
	Pulse( SCLK );
	do {
		Pulse( SCLK );
		wData = wData + (SDAT<<wJ);
		Inc( wJ );
	} while( wJ != 14 );
	Pulse( SCLK );
	SDAT.dir = 1;	// SDAT output mode
	Clear( SDAT );
}

write()
{
	PowerOn();

	bCmd = 0x09;	TXcmd();
	bCmd = 0x08;	TXcmd();
	Wait( 10, BASE_MS );
	bCmd = 0x17;	TXcmd();

	Clear( wFlg );
	Clear( wA );	// PIC̃AhX
	while( 1 ) {
		wLen = 256;
		if( DataReq( wFlg, wAH, wAL, bBuff, wLen ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	write_end;
		}
		wFlg = 1;		// pf[^ɐݒ肵Ă
		if( wLen == 0 ) {
			break;		// I
		}
		// wAH ͖gp
		wAL = wAL / 2;		// [h̃AhXɒ
		if( wAL >= 0x2000 && wA < 0x2000 ) {
			bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
			wData = 0x3fff;	WriteWordData();
			wA = 0x2000;
		}
		while( wA < wAL ) {	// ݊JnAhX܂ŃXLbv
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
		Clear( wI );
		while( wI != wLen ) {
			// P[h̏݃f[^obt@o
			// ʁAʔ]
			wWdata = bBuff[wI];
			Inc( wI );
			wWdata = wWdata + (bBuff[wI]<<8);
			Inc( wI );
			// 
			bCmd = 0x02;	TXcmd();	// 000010 Load Data for Program Memory
			wData = wWdata;
			WriteWordData();

			bCmd = 0x18;	TXcmd();
			Wait( 10, BASE_MS );
			bCmd = 0x17;	TXcmd();

			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
	}
write_end:
	PowerOff();
}

read()
{
	PowerOn();

	Clear( wA );
	wI = MAX_MEM * 2;		// _vTCYoCgPʂɂĒʒm
	StartDump( 0, 0, wI );	// _vf[^
	while( wA < MAX_MEM ) {
		ReadWordData();
		bD = wData & 0xff;	// 
		DataDump( bD );
		bD = wData>>8;		// 
		DataDump( bD );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
		Inc( wA );
	}

	// configẽ_v
	bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
	wData = 0x3fff;	WriteWordData();
	wA = 0x2000;
	while( wA < 0x2007 ) {
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
		Inc( wA );
	}
	wI = 2 * 2;		// _vTCYoCgPʂɂĒʒm
	StartDump( 0, 0x400e, wI );	// _vf[^
	ReadWordData();
	bD = wData & 0xff;	// 
	DataDump( bD );
	bD = wData>>8;		// 
	DataDump( bD );
	bCmd = 0x06;	TXcmd();	// 000110 Increment Address
	ReadWordData();
	bD = wData & 0xff;	// 
	DataDump( bD );
	bD = wData>>8;		// 
	DataDump( bD );

	EndDump();

	PowerOff();
}

verify()
{
	PowerOn();

	Clear( wFlg );
	Clear( wA );	// PIC̃AhX
	while( 1 ) {
		wLen = 256;
		if( DataReq( wFlg, wAH, wAL, bBuff, wLen ) != 0 ) {
			Message( "xt@Cf[^MɎs܂" );
			goto	write_end;
		}
		wFlg = 1;		// pf[^ɐݒ肵Ă
		if( wLen == 0 ) {
			break;		// I
		}
		// wAH ͖gp
		wAL = wAL / 2;		// [h̃AhXɒ
		if( wAL >= 0x2000 && wA < 0x2000 ) {
			bCmd = 0x00;	TXcmd();	// 000000 Load Configuration
			wData = 0x3fff;	WriteWordData();
			wA = 0x2000;
		}
		while( wA < wAL ) {	// xt@CJnAhX܂ŃXLbv
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
		Clear( wI );
		while( wI != wLen ) {
			// P[h̏݃f[^obt@o
			// ʁAʔ]
			wWdata = bBuff[wI];
			Inc( wI );
			wWdata = wWdata + (bBuff[wI]<<8);
			Inc( wI );
			// ǂݏo
			ReadWordData();
			// r
			if( wData != wWdata ) {
				StartMsg();
				SendMsg("xt@CG[ AhX(Word) = ");
				bD = wA>>8;
				SendHex(bD);
				bD = wA&0xff;
				SendHex(bD);
				SendMsg("(HEX)");
				EndMsg();	// ̏I
				goto	verify_end;
			}

			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
	}
	Message( "xt@CI܂" );
verify_end:

	PowerOff();
}

TXcmd()
{
	Clear( wJ );
	do {
		SDAT = bCmd>>wJ;
		Pulse( SCLK );
		Inc( wJ );
	} while( wJ != 6 );
	Clear( SDAT );
	Wait( 1, BASE_MS );
}

ReadWordDataDM()
{
	bCmd = 0x05;	TXcmd();	// 000101 Read Data from Data Memory
	SDAT.dir = 0;	// SDAT input mode
	Wait( 1, BASE_MS );

	Clear( wJ );
	Clear( wData );
	Pulse( SCLK );
	do {
		Pulse( SCLK );
		wData = wData + (SDAT<<wJ);
		Inc( wJ );
	} while( wJ != 14 );
	Pulse( SCLK );
	SDAT.dir = 1;	// SDAT output mode
	Clear( SDAT );
}

eeprom_write()
{
	PowerOn();

	bCmd = 0x0b;	TXcmd();
	bCmd = 0x08;	TXcmd();
	Wait( 10, BASE_MS );
	bCmd = 0x17;	TXcmd();

	Clear( wFlg );
	Clear( wA );	// PIC̃AhX
	while( 1 ) {
		wLen = 64;
		if( DataReq( wFlg, wAH, wAL, bBuff, wLen ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	eeprom_write_end;
		}
		wFlg = 1;		// pf[^ɐݒ肵Ă
		if( wLen == 0 ) {
			break;		// I
		}
		while( wA < wAL ) {	// ݊JnAhX܂ŃXLbv
			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
		Clear( wI );
		while( wI != wLen ) {
			// PoCg̏݃f[^obt@o
			wWdata = bBuff[wI];
			Inc( wI );
			// 
			bCmd = 0x03;	TXcmd();	// 000011 Load Data for Data Memory
			wData = wWdata;
			WriteWordData();
			bCmd = 0x18;	TXcmd();
			Wait( 10, BASE_MS );
			bCmd = 0x17;	TXcmd();
			// xt@C
			ReadWordDataDM();
			wData = wData & 0xff;
			if( wData != wWdata ) {
				StartMsg();
				SendMsg("xt@CG[ AhX(Byte) = ");
				SendHex(wA);
				SendMsg("(HEX)");
				EndMsg();	// ̏I
				break;
			}

			bCmd = 0x06;	TXcmd();	// 000110 Increment Address
			Inc( wA );
		}
	}
eeprom_write_end:
	PowerOff();
}

eeprom_read()
{
	PowerOn();

	Clear( wA );
	StartDump( 0, 0, MAX_EEPROM );	// _vf[^
	while( wA < MAX_EEPROM ) {
		ReadWordDataDM();
		bD = wData;
		DataDump( bD );
		bCmd = 0x06;	TXcmd();	// 000110 Increment Address
		Inc( wA );
	}
	EndDump();

	PowerOff();
}
