[TITLE]
24LC256

[AUTORUN]
setup

[MENU]
eeprom_read,0,w,ǂݏo
eeprom_write,1,r,݁{xt@C
eeprom_verify,0,r,xt@C
eeprom_erase,1,,SĂFF(H)

[MESSAGE]

[COMPILE]
on

[CODE]
#port	A	"1,2,3"
#define	VCC			#VCC40
#define	VCC.dir		#VCC40.dir
#define	GND			#GND4
#define	GND.dir		#GND4.dir
#define	DAT			#37
#define	DAT.dir		#37.dir
#define	CLK			#38
#define	CLK.dir		#38.dir
#define	WP			#39
#define	WP.dir		#39.dir
#define	MEM_SIZE	0x8000

WORD	wAdr, wAdrH, wAdrL, wLen, wI, wLoop;
BYTE	bMask, bData, bAck, bStatus;
BYTE	bFlg, bBuff[256];

pullup_on()
{
	mset( PU37AH, PU37AL, PU37DT );	// SDA(#37)vAbv
}

pullup_off()
{
	mset( PU37AH, PU37AL, 0x00 );	// SDA(#37)v_E
}

setup()
{
	InitIo();
	InitVolt();
	VccVolt( 5.0 );
	A.dir   = 0x7;	A = 0;
	VCC.dir = 1;	VCC = OFF;
	GND.dir = 1;	GND = ON;
	DAT.dir = 1;	DAT = 0;
	CLK.dir = 1;	CLK = 0;
	WP.dir  = 1;	WP = 0;
}

PowerOn()
{
	pullup_on();
	VCC = ON;
	Wait( 100, BASE_MS );
}

PowerOff()
{
	VCC = OFF;
	Clear( CLK );
	Clear( DAT );
	pullup_off();
}

start_condition()
{
	DAT = 1;		// CLK=?  DAT=1
	CLK = 1;		// CLK=1  DAT=1
	Clear( DAT );	// CLK=1  DAT=0
	Clear( CLK );	// CLK=0  DAT=0
}

stop_condition()
{
	Clear( DAT );
	CLK = 1;		// CLK=1  DAT=0
	DAT = 1;		// CLK=1  DAT=1
}

write_data()
{
	bMask = 0x80;
	do {
		if( bData & bMask ) {
			DAT = 1;
		} else {
			Clear( DAT );
		}
		Pulse( CLK );
		bMask = bMask >> 1;
	} while( bMask );
	DAT.dir = 0;	// ̓[h
	CLK = 1;
	bAck = DAT;
	Clear( CLK );
	Clear( DAT );
	DAT.dir = 1;
}

read_data()
{
	bMask = 0x80;
	DAT.dir = 0;	// ̓[h
	Clear( bData );
	do {
		CLK = 1;
		if( DAT ) {
			bData = bData | bMask;
		}
		Clear( CLK );
		bMask = bMask >> 1;
	} while( bMask );
	Clear( DAT );
	DAT.dir = 1;
}

access_start()
{
	Clear( wI );
	bData = 0xa0;		/* 1010xxx0 ݎw */
	do {
		Inc( wI );
		if( wI == 500 ) {
			Message("foCX牞܂");
			Clear( CLK );
			Clear( DAT );
			exit(0);
		}
		start_condition();
//		bData = 0xa0;		/* 1010xxx0 ݎw */
		write_data();
	} while( bAck == 1 );
}

eeprom_read()
{
	PowerOn();

	access_start();

	/* AhXʁAʑo */
	Clear( bData );	/* ʂWrbg */
	write_data();
	Clear( bData );	/* ʂWrbg */
	write_data();

	/* X^[gRfBV */
	start_condition();

	bData = 0xa1;		/* 1010xxx1 ǂݍݎw */
	write_data();

	Message("f[^̃_vJn܂");

	Clear( wAdr );
	StartDump( 0, 0, MEM_SIZE );	// _vf[^
	while( 1 ) {
		read_data();
		DataDump( bData );
		Inc( wAdr );
		if( wAdr == MEM_SIZE ) {
			/* no ack */
			DAT = 1;
			Pulse( CLK );
			Clear( DAT );
			break;
		} else {
			/* ack */
			Clear( DAT );
			Pulse( CLK );
		}
	}
	stop_condition();
	EndDump();
	Message("f[^̃_vI܂");
	PowerOff();
}

eeprom_write()
{
	PowerOn();
	bStatus = 0;

	ee_write_sub();
	if( bStatus == 0 ) {
		ee_verify_sub();
	}
	PowerOff();
}

ee_write_sub()
{
	Message("f[^݂̏Jn܂");
	Clear( bFlg );	/* 0:̗v */
	while( 1 ) {
		access_start();
		wLen = 32;	/* P݂͍̏ő32 */
		/* wAdrH ̓_~[ */
		if( DataReq( bFlg, wAdrH, wAdrL, bBuff, wLen ) != 0 ) {
			Message("݃f[^̎MɎs܂");
			bStatus = 1;
			return();
		}
		if( wLen == 0 ) {
			Message("f[^݂̏I܂");
			return();
		}
		bFlg = 1;	/* pv */
		/* AhXʁAʑo */
		bData = wAdrL>>8;		/* ʂWrbg */
		write_data();
		bData = wAdrL&0xff;	/* ʂWrbg */
		write_data();
		Clear( wLoop );
		do {
			bData = bBuff[wLoop];
			write_data();
			Inc( wLoop );
		} while( wLoop != wLen );
		stop_condition();
	}
}

eeprom_verify()
{
	PowerOn();

	ee_verify_sub();

	PowerOff();
}

ee_verify_sub()
{
	Message("xt@CJn܂");
	bFlg = 0;		/* 0:̗v */
	while( 1 ) {
		wLen = 256;
		/* wAdrH ̓_~[ */
		if( DataReq( bFlg, wAdrH, wAdrL, bBuff, wLen ) != 0 ) {
			Message("xt@Cf[^̎MɎs܂");
			return();
		}
		if( wLen == 0 ) {
			Message("xt@CɏI܂");
			return();
		}
		bFlg = 1;	/* pv */

		access_start();

		/* AhXʁAʑo */
		bData = wAdrL>>8;		/* ʂWrbg */
		write_data();
		bData = wAdrL&0xff;	/* ʂWrbg */
		write_data();

		/* X^[gRfBV */
		start_condition();

		bData = 0xa1;		/* 1010xxx1 ǂݍݎw */
		write_data();
		wLoop = 0;
		while( 1 ) {
			read_data();
			if( bData != bBuff[wLoop] ) {
				StartMsg();	SendMsg("xt@Cُł adr = ");
				wI = (wAdrL+wLoop)>>8;
				SendHex(wI);
				wI = (wAdrL+wLoop)&0xff;
				SendHex(wI);
				SendMsg("(HEX)  data = read:");
				SendHex(bData);
				SendMsg(", file:");
				wI = bBuff[wLoop];
				SendHex(wI);
				EndMsg();
				return();
			}
			Inc( wLoop );
			if( wLoop == wLen ) {
				/* no ack */
				DAT = 1;
				Pulse( CLK );
				Clear( DAT );
				break;
			} else {
				/* ack */
				DAT = 0;
				Pulse( CLK );
			}
		}
		stop_condition();
	}
}

eeprom_erase()
{
	PowerOn();

	Message("SĂFF(H)݂܂");
	Clear( wAdr );
	do {
		access_start();
		wLen = 32;	/* P݂͍̏ő32 */
		/* AhXʁAʑo */
		bData = wAdr>>8;		/* ʂWrbg */
		write_data();
		bData = wAdr&0xff;	/* ʂWrbg */
		write_data();
		Clear( wLoop );
		bData = 0xff;
		do {
			write_data();
			Inc( wLoop );
		} while( wLoop != wLen );
		wAdr = wAdr + wLen;
		if( (wAdr & 0xff) == 0 ) {
			StartMsg();
			wI = wAdr>>8;
			SendHex(wI);
			wI = wAdr&0xff;
			SendHex(wI);
			SendMsg("(H) ܂Ŋ");
			EndMsg();
		}
		stop_condition();
	} while( wAdr < MEM_SIZE );


	Message("݃`FbNJn܂");
	access_start();

	/* AhXʁAʑo */
	Clear( bData );	/* ʂWrbg */
	write_data();
	Clear( bData );	/* ʂWrbg */
	write_data();

	/* X^[gRfBV */
	start_condition();

	bData = 0xa1;		/* 1010xxx1 ǂݍݎw */
	write_data();
	Clear(wAdr);
	while( 1 ) {
		read_data();
		if( bData != 0xff ) {
			StartMsg();	SendMsg("݃`FbNُł adr = ");
			wI = wAdr>>8;
			SendHex(wI);
			wI = wAdr&0xff;
			SendHex(wI);
			SendMsg("(HEX)");
			EndMsg();
			PowerOff();
			return();
		}
		Inc( wAdr );
		if( wAdr == MEM_SIZE ) {
			/* no ack */
			DAT = 1;
			Pulse( CLK );
			Clear( DAT );
			break;
		} else {
			/* ack */
			DAT = 0;
			Pulse( CLK );
		}
	}
	stop_condition();

	Message("I܂");
	PowerOff();
}
