[TITLE]
AT90S8515

[AUTORUN]
setup

[MENU]
Write,1,r,{݁{xt@C
Read,0,w,ǂݏo
Verify,0,r,xt@C
EeWrite,1,r,EEPROM݁{xt@C
EeRead,0,w,EEPROMǂݏo
FuseWrite,0,,q[Yf[^
FuseRead,0,,q[Yf[^ǂݏo
ReadSig,0,,VOl`[ǂݏo

[MESSAGE]

[CODE]
//           D0            D7
#port	D	"1,2,3,4,5,6,7,8"
#define	VPP			#VPP9
#define	VPP.dir		#VPP9.dir
#define	#RESET		#9
#define	#RESET.dir	#9.dir
#define	VCC			#VCC40
#define	VCC.dir		#VCC40.dir
#define	GND			#GND20
#define	GND.dir		#GND20.dir
#define	RDY			#11
#define	RDY.dir		#11.dir
#define	#OE			#12
#define	#OE.dir		#12.dir
#define	#WR			#13
#define	#WR.dir		#13.dir
#define	BS			#14
#define	BS.dir		#14.dir
#define	XA0			#15
#define	XA0.dir		#15.dir
#define	XA1			#16
#define	XA1.dir		#16.dir
#define	XTAL1		#19
#define	XTAL1.dir	#19.dir
#define	MEM_SIZEB	8192	// oCgPʂ̃TCY
#define	MEM_SIZEW	4096	// [hPʂ̃TCY
#define	MEM_EEDATA	512		// EEPROM̃TCY

WORD	i, Flg, AH, A, Len;
BYTE	Buff[256];			// oCgPʂ̃TCY
BYTE	Data;

setup()
{
	InitIo();
	InitVolt();
	VppVolt( 12.0 );	VccVolt( 5.0 );
	VPP.dir = 1;	VPP = 0;
	VCC.dir = 1;	VCC = 0;
	GND.dir = 1;	GND = 1;
	RDY.dir = 0;
	#RESET.dir = 1;	#RESET = 0;
	#OE.dir = 1;	#OE = 0;
	#WR.dir = 1;	#WR = 0;
	BS.dir  = 1;	BS  = 0;
	XA0.dir = 1;	XA0 = 0;
	XA1.dir = 1;	XA1 = 0;
	XTAL1.dir = 1;	XTAL1 = 0;
	D.dir = 0xff;	D = 0;
	Message("Pԃsɍ킹ăfoCXZbgĉ");
}

PowerOn()
{
	#RESET = 0;
	VCC = 1;
	Wait( 10, BASE_MS );
	#OE = 1;
	#WR = 1;
	VPP = 1;
	Wait( 2, BASE_MS );
	BS  = 0;
	XA0 = 1;
	XA1 = 1;
	XTAL1 = 0;
	Clear( i );
	do {
		if( RDY != 0 ) {
			return();
		}
		Inc( i );
	} while( i != 500 );
	Message( "foCXfBԂɂȂ܂" );
	PowerOff();
	exit( 0 );
}

PowerOff()
{
	#RESET = 0;
	VPP = 0;
	#OE = 0;
	#WR = 0;
	BS  = 0;
	XA0 = 0;
	XA1 = 0;
	XTAL1 = 0;
	D.dir = 0xff;	D = 0;
	VCC = 0;
	Message("dՒf܂" );
}

Write()
{
	PowerOn();

	Message( "`bvC[XJn܂" );
	XA1 = 1;	XA0 = 0;
	D = 0x80;	// 10000000:Chip erase
	Pulse( XTAL1 );
	#WR = 0;	#WR = 1;
	Wait( 200, BASE_MS );

	Message( "vO~OJn܂" );
	XA1 = 1;	XA0 = 0;
	D = 0x10;	// 00010000:Programming the Flash
	Pulse( XTAL1 );

	Flg = 0;
	while( 1 ) {
		Len = 256;
		if( DataReq( Flg, AH, A, Buff, Len ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	write_end;
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		A = A / 2;		/* [h̃AhXɒ */
		Clear( i );
		while( i != Len ) {
			XA1 = 0;	XA0 = 0;
			BS = 1;
			D = A>>8;
			Pulse( XTAL1 );
			BS = 0;
			D = A&0xff;
			Pulse( XTAL1 );

			XA1 = 0;	XA0 = 1;
			D = Buff[i];
			if( D != 0xff ) {
				Pulse( XTAL1 );
				#WR = 0;	#WR = 1;
				SetTimer( 10, BASE_MS );
				while( RDY == 0 ) {
					if( GetTimer() == 0 ) {
						break;
					}
				}
			}
			Inc( i );
			D = Buff[i];
			if( D != 0xff ) {
				BS = 1;
				Pulse( XTAL1 );
				#WR = 0;	#WR = 1;
				SetTimer( 10, BASE_MS );
				while( RDY == 0 ) {
					if( GetTimer() == 0 ) {
						break;
					}
				}
			}
			Inc( i );
			Inc( A );
		}
	}

	Wait( 200, BASE_MS );
	VerifySub();

write_end:

	PowerOff();
}

Read()
{
	PowerOn();

	XA1 = 1;	XA0 = 0;
	D = 0x02;	// 00000010:Reading the Flash
	Pulse( XTAL1 );

	Clear( A );
	StartDump( 0, 0, MEM_SIZEB );	// _vf[^
	while( A < MEM_SIZEW ) {
		XA1 = 0;	XA0 = 0;
		if( (A&0xff) == 0 ) {
			BS = 1;
			D = A>>8;
			Pulse( XTAL1 );
		}
		BS = 0;
		D = A&0xff;
		Pulse( XTAL1 );

		D.dir = 0;
		#OE = 0;
		DataDump( D );
		BS = 1;
		DataDump( D );
		#OE = 1;
		D.dir = 0xff;
		Inc( A );
	}
	EndDump();
	Message( "ǂݏoI܂" );

	PowerOff();
}

Verify()
{
	PowerOn();

	VerifySub();

	PowerOff();
}

VerifySub()
{
	Message( "xt@CJn܂" );
	BS = 0;
	XA1 = 1;	XA0 = 0;
	D = 0x02;	// 00000010:Reading the Flash
	Pulse( XTAL1 );

	Flg = 0;
	while( 1 ) {
		Len = 256;
		if( DataReq( Flg, AH, A, Buff, Len ) != 0 ) {
			Message( "xt@Cf[^MɎs܂" );
			return();
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		A = A / 2;		/* [h̃AhXɒ */
		Clear( i );
		while( i != Len ) {
			XA1 = 0;	XA0 = 0;
			BS = 1;
			D = A>>8;
			Pulse( XTAL1 );
			BS = 0;
			D = A&0xff;
			Pulse( XTAL1 );

			D.dir = 0;
			#OE = 0;
			if( D != Buff[i] ) {
				Message( "xt@CG[" );
				StartMsg();	// ̊Jn
				SendMsg("sAhX(Word) = ");
				Data = A>>8;
				SendHex(Data);
				Data = A&0xff;
				SendHex(Data);
				SendMsg("(HEX)");
				EndMsg();	// ̏I
				#OE = 1;
				D.dir = 0xff;
				return();
			}
			BS = 1;
			Inc( i );
			if( D != Buff[i] ) {
				Message( "xt@CG[" );
				StartMsg();	// ̊Jn
				SendMsg("sAhX(Word) = ");
				Data = A>>8;
				SendHex(Data);
				Data = A&0xff;
				SendHex(Data);
				SendMsg("(HEX)");
				EndMsg();	// ̏I
				#OE = 1;
				D.dir = 0xff;
				return();
			}
			#OE = 1;
			D.dir = 0xff;
			Inc( i );
			Inc( A );
		}
	}
	Message( "xt@CɏI܂" );
}

EeWrite()
{
	PowerOn();

	XA1 = 1;	XA0 = 0;
	D = 0x11;	// 00010001:Programming the EEPROM
	Pulse( XTAL1 );

	Flg = 0;
	while( 1 ) {
		Len = 64;
		if( DataReq( Flg, AH, A, Buff, Len ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			goto	ee_write_end;
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		if( (A+Len) > MEM_EEDATA ) {
			Message( "݃f[^EEPROMTCYzĂ܂" );
			goto	ee_write_end;
		}
		Clear( i );
		while( i != Len ) {
			XA1 = 0;	XA0 = 0;
// AT90S8515
			BS = 1;
			D = A>>8;
			Pulse( XTAL1 );
			BS = 0;
			D = A&0xff;
			Pulse( XTAL1 );

			XA1 = 0;	XA0 = 1;
			D = Buff[i];
			Pulse( XTAL1 );
			#WR = 0;	#WR = 1;
			SetTimer( 10, BASE_MS );
			while( RDY == 0 ) {
				if( GetTimer() == 0 ) {
					break;
				}
			}
			Inc( i );
			Inc( A );
		}
	}

	EeVerifySub();

ee_write_end:

	PowerOff();
}

EeVerifySub()
{
	Message( "xt@CJn܂(EEPROM)" );
	BS = 0;
	XA1 = 1;	XA0 = 0;
	D = 0x03;	// 00000011:Reading the EEPROM
	Pulse( XTAL1 );

	Flg = 0;
	while( 1 ) {
		Len = 64;
		if( DataReq( Flg, AH, A, Buff, Len ) != 0 ) {
			Message( "xt@Cf[^MɎs܂" );
			return();
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		Clear( i );
		while( i != Len ) {
			XA1 = 0;	XA0 = 0;
// AT90S8515
			BS = 1;
			D = A>>8;
			Pulse( XTAL1 );
			BS = 0;
			D = A&0xff;
			Pulse( XTAL1 );

			D.dir = 0;
			#OE = 0;
			if( D != Buff[i] ) {
				Message( "xt@CG[" );
				StartMsg();	// ̊Jn
				SendMsg("sAhX(Byte) = ");
//				Data = A>>8;
//				SendHex(Data);
				Data = A&0xff;
				SendHex(Data);
				SendMsg("(HEX)");
				EndMsg();	// ̏I
				#OE = 1;
				D.dir = 0xff;
				return();
			}
			#OE = 1;
			D.dir = 0xff;
			Inc( i );
			Inc( A );
		}
	}
	Message( "xt@CɏI܂" );
}

EeRead()
{
	PowerOn();

	XA1 = 1;	XA0 = 0;
	D = 0x03;	// 00000011:Reading the EEPROM
	Pulse( XTAL1 );

	A = 0;
	StartDump( 0, 0, MEM_EEDATA );	// _vf[^
	while( A < MEM_EEDATA ) {
		XA1 = 0;	XA0 = 0;
// AT90S8515
		BS = 1;
		D = A>>8;
		Pulse( XTAL1 );
		BS = 0;
		D = A&0xff;
		Pulse( XTAL1 );

		D.dir = 0;
		#OE = 0;
		DataDump( D );
		#OE = 1;
		D.dir = 0xff;
		Inc( A );
	}
	EndDump();
	Message( "ǂݏoI܂" );

	PowerOff();
}

FuseWrite()
{
	SendCode( KEY_ON );		// L[{[h͗L
	SendCode( BUTTON_OFF );	// {^
	while( 1 ) {
		Message( " 0:short start-up time  1:Default start-up time  2:~  ?" );
		i = RecByte();
		if( i == '2' ) {
			Message( "݂𒆎~܂" );
			SendCode( KEY_OFF );	// L[{[h͖
			SendCode( BUTTON_ON );	// {^L
			exit(0);
		}
		if( i == '0' ) {
			Data = 0xfe;
			break;
		}
		if( i == '1' ) {
			Data = 0xff;
			break;
		}
	}
	PowerOn();
	XA1 = 1;	XA0 = 0;
	BS = 0;
	D = 0x40;	// 01000000:Programming the Fuse Bits
	Pulse( XTAL1 );
	XA1 = 0;	XA0 = 1;
	D = Data;
	Pulse( XTAL1 );
	#WR = 0;
	Wait( 2, BASE_MS );
	#WR = 1;
	Wait( 200, BASE_MS );
	FuseReadSub();
	PowerOff();

	SendCode( KEY_OFF );	// L[{[h͖
	SendCode( BUTTON_ON );	// {^L
}

FuseRead()
{
	PowerOn();

	FuseReadSub();

	PowerOff();
}

FuseReadSub()
{
	XA1 = 1;	XA0 = 0;
	D = 0x04;	// 00000100:Reading the Fuse and Lock Bits
	Pulse( XTAL1 );

	D.dir = 0;
	#OE = 0;
	BS = 1;
	StartMsg();
	SendMsg( "Fuse = " );
	SendHex( D ) ;
	if( D&0x01 ) {
		SendMsg( "  1:Default start-up time" );
	} else {
		SendMsg( "  0:short start-up time" );
	}
	EndMsg();
	#OE = 1;
	D.dir = 0xff;
}

ReadSig()
{
	PowerOn();

	XA1 = 1;	XA0 = 0;
	D = 0x08;	// 00001000:Reading the Signature
	Pulse( XTAL1 );

	StartMsg();
	SendMsg( "Signature (90S8515:1E9301) = " );
	XA1 = 0;	XA0 = 0;
	BS = 0;
	D = 0;
	Pulse( XTAL1 );

	D.dir = 0;
	#OE = 0;
	BS = 0;
	SendHex( D );
	#OE = 1;
	D.dir = 0xff;
	D = 1;
	Pulse( XTAL1 );
	D.dir = 0;
	#OE = 0;
	BS = 0;
	SendHex( D );
	#OE = 1;
	D.dir = 0xff;
	D = 2;
	Pulse( XTAL1 );
	D.dir = 0;
	#OE = 0;
	BS = 0;
	SendHex( D );
	#OE = 1;
	D.dir = 0xff;

	EndMsg();

	PowerOff();
}
